#!/bin/sh
#
# Start the isp_media_server in the configuration for Basler daA3840-30mc
#

RUNTIME_DIR="$( cd "$(dirname "$0")" >/dev/null 2>&1 ; pwd -P )"
BASLER=`dmesg | grep Basler`

# check if the basler device has been enabled in the device tree
if [ ! -z "$BASLER" ]; then
	echo "Starting isp_media_server for Basler daA3840-30mc"
	cd $RUNTIME_DIR
	# TODO: remove format below, when proper format interface is present in isp media control
	# uncomment corresponding line to enable 1080p60 ("-c basler_1080p60") or 4kp30 ("-c basler_4k")
	#exec ./run.sh -c basler_4k
	exec ./run.sh -c basler_1080p60
else
	# no device tree found exit with code no device or address
	echo "Basler camera not found!" >&2
	exit 6
fi
